Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotat_nfil.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotat_nfil.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotat_nfil.F	(revision 4727)
@@ -15,7 +15,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 c
 c   .....  variables en arguments  ......
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotatf.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotatf.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotatf.F	(revision 4727)
@@ -16,7 +16,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 c
 c   .....  variables en arguments  ......
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotatst.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotatst.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/rotatst.F	(revision 4727)
@@ -16,6 +16,6 @@
 c
       INTEGER klevel
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
 
       REAL rot( ip1jm,klevel )
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/test_period.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/test_period.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3d_common/test_period.F	(revision 4727)
@@ -13,6 +13,6 @@
 c     IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
 c
 c    ......  Arguments   ......
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/abort_gcm.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/abort_gcm.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/abort_gcm.F	(revision 4727)
@@ -13,5 +13,5 @@
 #endif
       USE parallel_lmdz
-#include "iniprint.h"
+      INCLUDE "iniprint.h"
  
 C
@@ -47,11 +47,13 @@
       else
         write(lunout,*) 'Houston, we have a problem, ierr = ', ierr
-#ifdef CPP_MPI
+
+        if (using_mpi) THEN
 C$OMP CRITICAL (MPI_ABORT_GCM)
-        call MPI_ABORT(COMM_LMDZ, 1, ierror_mpi)
+          call MPI_ABORT(COMM_LMDZ, 1, ierror_mpi)
 C$OMP END CRITICAL (MPI_ABORT_GCM)
-#else
-        stop 1
-#endif          
+        else
+         stop 1
+        endif          
+      
       endif
       END
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/bilan_dyn_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/bilan_dyn_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/bilan_dyn_loc.F	(revision 4727)
@@ -141,7 +141,6 @@
       character*10 infile
 
-      integer fileid
+      integer, save :: fileid
       integer thoriid, zvertiid
-      save fileid
 
       INTEGER,SAVE,ALLOCATABLE :: ndex3d(:)
@@ -838,4 +837,8 @@
 c/////////////////////////////////////////////////////////////////////
 c=====================================================================
+!$OMP MASTER
+      call histsync(fileid)
+!$OMP END MASTER
+
 
       return
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/conf_gcm.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/conf_gcm.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/conf_gcm.F90	(revision 4727)
@@ -19,5 +19,5 @@
   USE comconst_mod, ONLY: dissip_deltaz, dissip_factz, dissip_zref, &
                           iflag_top_bound, mode_top_bound, tau_top_bound, &
-                          ngroup
+                          ngroup, maxlatfilter
   USE logic_mod, ONLY: fxyhypb, iflag_phys, ok_etat0, ok_gradsfile, &
                        ok_guide, ok_limit, ok_strato, purmats, read_start, &
@@ -25,5 +25,5 @@
   USE serre_mod, ONLY: clon,clat,grossismx,grossismy,dzoomx,dzoomy, &
                        alphax,alphay,taux,tauy
-  USE temps_mod, ONLY: calend, year_len
+  USE temps_mod, ONLY: calend, year_len, offline_time
 
   IMPLICIT NONE
@@ -341,4 +341,12 @@
   CALL getin('dissip_zref',dissip_zref )
 
+
+  !maxlatfilter
+  maxlatfilter = -1.0
+  CALL getin('maxlatfilter',maxlatfilter)
+  if (maxlatfilter > 90) &
+       call abort_gcm("conf_gcm", 'maxlatfilter should be <=90', 1)
+  
+
   ! ngroup
   ngroup=3
@@ -620,10 +628,18 @@
 
      !Config  Key  = offline
-     !Config  Desc = Nouvelle eau liquide
+     !Config  Desc = ecriture des flux de masse
      !Config  Def  = n
-     !Config  Help = Permet de mettre en route la
-     !Config         nouvelle parametrisation de l'eau liquide !
+     !Config  Help = Permet de sortir les flux de masse sur la grille plev 
      offline = .FALSE.
      CALL getin('offline',offline)
+
+     !Config Key  = offline_time
+     !Config Desc =  Choix des frequences de stockage pour le offline
+     !Config Def  = 8
+     !Config Help = offline_time=12     ! stockage toutes les 2h=1jour/12
+     !Config Help = offline_time=8      ! stockage toutes les 3h=1jour/8
+     offline_time = 8
+     CALL getin('offline_time',offline_time)
+
      IF (offline .AND. adjust) THEN
         WRITE(lunout,*)  &
@@ -714,4 +730,5 @@
      write(lunout,*)' tauyy = ', tauyy
      write(lunout,*)' offline = ', offline
+     write(lunout,*)' offline_time = ', offline_time
      write(lunout,*)' type_trac = ', type_trac
      write(lunout,*)' ok_dynzon = ', ok_dynzon 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/convflu_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/convflu_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/convflu_loc.F	(revision 4727)
@@ -18,6 +18,6 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
       REAL       xflu,yflu,convfl,convpn,convps
       INTEGER    l,ij,nbniv
@@ -30,5 +30,5 @@
 c
 c
-#include "comgeom.h"
+      INCLUDE "comgeom.h"
 c
      
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/covcont_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/covcont_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/covcont_loc.F	(revision 4727)
@@ -17,7 +17,7 @@
 c=======================================================================
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 
       INTEGER klevel
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/covnat_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/covnat_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/covnat_loc.F	(revision 4727)
@@ -20,7 +20,7 @@
 c=======================================================================
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 
       INTEGER klevel
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/diverg_gam_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/diverg_gam_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/diverg_gam_loc.F	(revision 4727)
@@ -21,7 +21,7 @@
 c
 c   ---------------------------------------------------------------------
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 c
 c    ..........          variables en arguments    ...................
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/diverg_p.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/diverg_p.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/diverg_p.F	(revision 4727)
@@ -20,7 +20,7 @@
 c
 c   ---------------------------------------------------------------------
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 c
 c    ..........          variables en arguments    ...................
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/divergf_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/divergf_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/divergf_loc.F	(revision 4727)
@@ -21,7 +21,7 @@
 c
 c   ---------------------------------------------------------------------
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 c
 c    ..........          variables en arguments    ...................
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/divgrad2_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/divgrad2_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/divgrad2_loc.F	(revision 4727)
@@ -16,8 +16,8 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom2.h"
-#include "comdissipn.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom2.h"
+      INCLUDE "comdissipn.h"
 
 c    .......    variables en arguments   .......
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/dudv1_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/dudv1_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/dudv1_loc.F	(revision 4727)
@@ -17,6 +17,6 @@
 c-----------------------------------------------------------------------
 
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
 
       REAL vorpot( ijb_v:ije_v,llm ) ,pbaru( ijb_u:ije_u,llm ) ,
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/dynetat0_loc.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/dynetat0_loc.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/dynetat0_loc.F90	(revision 4727)
@@ -183,7 +183,18 @@
          CALL msg('Tracer <'//TRIM(var)//'> is missing => initialized with a simplified Rayleigh distillation law.', modname)
          q(ijb_u:ije_u,:,iq) = q(ijb_u:ije_u,:,iqParent)*tnat*(q(ijb_u:ije_u,:,iqParent)/30.e-3)**(alpha_ideal-1.)
+         ! Camille 9 mars 2023: point de vigilence: initialisation incohérente
+         ! avec celle de xt_ancien dans la physiq.
       ELSE
          CALL msg('Tracer <'//TRIM(var)//'> is missing => initialized to its parent isotope concentration.', modname)
-         q(ijb_u:ije_u,:,iq) = q(ijb_u:ije_u,:,iqIsoPha(iName,iPhase))
+         ! Camille 9 mars 2023: attention!! seuls les tags qui correspondent à
+         ! izone=izone_init (définie dans isotrac_mod) sont initialisés comme
+         ! les parents. Sinon, c'est nul.
+         ! j'ai fait ça en attendant, mais il faudrait initialiser proprement en
+         ! remplacant 1 par izone_init dans la ligne qui suit.
+         IF(tracers(iq)%iso_iZone == 1) THEN
+          q(ijb_u:ije_u,:,iq) = q(ijb_u:ije_u,:,iqIsoPha(iName,iPhase))
+         ELSE
+           q(ijb_u:ije_u,:,iq) =  0.
+         ENDIF
       END IF
     !--------------------------------------------------------------------------------------------------------------------------
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/filtreg_p.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/filtreg_p.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/filtreg_p.F	(revision 4727)
@@ -51,7 +51,7 @@
 c
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "coefils.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "coefils.h"
 c
       INTEGER ibeg,iend,nlat,nbniv,ifiltre,iter
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gcm.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gcm.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gcm.F90	(revision 4727)
@@ -28,7 +28,5 @@
                        itau_dyn,itau_phy,day_ini,jD_ref,jH_ref,day_end, &
                        dt,hour_ini,itaufin
-#ifdef CPP_XIOS
   USE mod_xios_dyn3dmem, ONLY: xios_dyn3dmem_init
-#endif
 
   IMPLICIT NONE
@@ -457,10 +455,8 @@
 
 ! setting up DYN3D/XIOS inerface
-#ifdef CPP_XIOS
-   if (ok_dyn_xios) then
-     CALL xios_dyn3dmem_init(xios_cal_type, anref, moisref, jourref,heureref, an,   &
+  if (ok_dyn_xios) then
+      CALL xios_dyn3dmem_init(xios_cal_type, anref, moisref, jourref,heureref, an,   &
           mois, jour, heure, zdtvr)
   endif
-#endif
 
   ! #endif of #ifdef CPP_IOIPSL
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gr_u_scal_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gr_u_scal_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gr_u_scal_loc.F	(revision 4727)
@@ -31,7 +31,7 @@
 c   ---------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 
 c   Arguments:
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gr_v_scal_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gr_v_scal_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gr_v_scal_loc.F	(revision 4727)
@@ -31,7 +31,7 @@
 c   ---------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 
 c   Arguments:
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/grad_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/grad_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/grad_loc.F	(revision 4727)
@@ -13,6 +13,6 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
       INTEGER klevel
       REAL  pg( ijb_u:ije_u,klevel )
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/grad_p.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/grad_p.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/grad_p.F	(revision 4727)
@@ -13,6 +13,6 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
       INTEGER klevel
       REAL  pg( ip1jmp1,klevel )
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gradiv2_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gradiv2_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/gradiv2_loc.F	(revision 4727)
@@ -21,8 +21,8 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
-#include "comdissipn.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
+      INCLUDE "comdissipn.h"
 c
 c     ........    variables en arguments      ........
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_gam_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_gam_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_gam_loc.F	(revision 4727)
@@ -14,7 +14,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 
 c
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_loc.F	(revision 4727)
@@ -13,7 +13,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 
 c
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_rot_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_rot_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_rot_loc.F	(revision 4727)
@@ -14,7 +14,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 
 c 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_rotgam_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_rotgam_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/laplacien_rotgam_loc.F	(revision 4727)
@@ -12,7 +12,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 
 c
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/leapfrog_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/leapfrog_loc.F	(revision 4727)
@@ -42,7 +42,8 @@
        USE temps_mod, ONLY: itaufin,jD_ref,jH_ref,day_ini,
      &                        day_ref,start_time,dt
-#ifdef CPP_XIOS
-       USE xios, ONLY: xios_update_calendar 
-#endif
+       USE mod_xios_dyn3dmem, ONLY : dyn3d_ctx_handle
+       USE lmdz_xios, ONLY: xios_update_calendar, 
+     &                      xios_set_current_context, 
+     &                      using_xios
        
       IMPLICIT NONE
@@ -1519,5 +1520,13 @@
 
 #ifdef INCA
-         if (ANY(type_trac == ['inca','inco'])) CALL finalize_inca
+         IF (ANY(type_trac == ['inca','inco'])) THEN
+            CALL finalize_inca
+!     switching back to LMDZDYN context
+!$OMP MASTER
+            IF (ok_dyn_xios) THEN
+               CALL xios_set_current_context(dyn3d_ctx_handle)
+            ENDIF
+!$OMP END MASTER
+         ENDIF
 #endif
 #ifdef REPROBUS
@@ -1568,5 +1577,13 @@
 
 #ifdef INCA
-              if (ANY(type_trac == ['inca','inco'])) CALL finalize_inca
+              IF (ANY(type_trac == ['inca','inco'])) THEN
+                 CALL finalize_inca
+!     switching back to LMDZDYN context
+!$OMP MASTER
+                 IF (ok_dyn_xios) THEN
+                    CALL xios_set_current_context(dyn3d_ctx_handle)
+                 ENDIF
+!$OMP END MASTER
+              ENDIF
 #endif
 #ifdef REPROBUS
@@ -1640,5 +1657,4 @@
 #endif
              
-#ifdef CPP_XIOS
               IF (ok_dyn_xios) THEN
 c$OMP MASTER
@@ -1649,5 +1665,4 @@
      &                 ucov,teta,pk,phi,q,masse,ps,phis)
               ENDIF
-#endif
               
           endif                 ! of if (leapf.or.(.not.leapf.and.(.not.forward)))
@@ -1735,5 +1750,14 @@
 
 #ifdef INCA
-              if (ANY(type_trac == ['inca','inco'])) CALL finalize_inca
+                 IF (ANY(type_trac == ['inca','inco'])) THEN
+                    CALL finalize_inca
+!     switching back to LMDZDYN context
+!$OMP MASTER
+                    IF (ok_dyn_xios) THEN
+                       CALL xios_set_current_context(dyn3d_ctx_handle)
+                    ENDIF
+!$OMP END MASTER
+                 ENDIF
+
 #endif
 #ifdef REPROBUS
@@ -1801,5 +1825,4 @@
 #endif
 
-#ifdef CPP_XIOS
               IF (ok_dyn_xios) THEN
 c$OMP MASTER
@@ -1810,5 +1833,4 @@
      &                 ucov,teta,pk,phi,q,masse,ps,phis)
               ENDIF
-#endif
               
            ENDIF                ! of IF(MOD(itau,iecri).EQ.0)
@@ -1842,5 +1864,14 @@
 
 #ifdef INCA
-      if (ANY(type_trac == ['inca','inco'])) CALL finalize_inca
+      IF (ANY(type_trac == ['inca','inco'])) THEN
+         CALL finalize_inca
+!     switching back to LMDZDYN context
+!$OMP MASTER
+         IF (ok_dyn_xios) THEN
+            CALL xios_set_current_context(dyn3d_ctx_handle)
+         ENDIF
+!$OMP END MASTER
+      ENDIF
+
 #endif
 #ifdef REPROBUS
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_const_mpi.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_const_mpi.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_const_mpi.F90	(revision 4727)
@@ -11,4 +11,6 @@
 
   SUBROUTINE Init_const_mpi
+    USE lmdz_mpi
+
 #ifdef CPP_IOIPSL
     USE IOIPSL, ONLY: getin
@@ -21,11 +23,6 @@
     USE mod_prism
 #endif
-#ifdef CPP_XIOS
-    USE wxios, only: wxios_init
-#endif
+    USE wxios, only: wxios_init, using_xios
     IMPLICIT NONE
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
 
     INTEGER             :: ierr
@@ -41,37 +38,32 @@
 !$OMP BARRIER
 
-    IF (type_ocean=='couple') THEN
+    IF (using_mpi) THEN
+      IF (type_ocean=='couple') THEN
 #ifdef CPP_COUPLE
 !$OMP MASTER
-#ifdef CPP_XIOS
-      CALL wxios_init("LMDZ", outcom=COMM_LMDZ, type_ocean=type_ocean)
-#else
-       CALL prism_init_comp_proto (comp_id, 'LMDZ', ierr)
-       CALL prism_get_localcomm_proto(COMM_LMDZ,ierr)
-#endif
+        IF (using_xios) THEN
+          CALL wxios_init("LMDZ", outcom=COMM_LMDZ, type_ocean=type_ocean)
+        ELSE
+          CALL prism_init_comp_proto (comp_id, 'LMDZ', ierr)
+          CALL prism_get_localcomm_proto(COMM_LMDZ,ierr)
+        ENDIF
 !$OMP END MASTER
 #endif
-#ifdef CPP_MPI
-      MPI_REAL_LMDZ=MPI_REAL8
-#endif
-    ELSE
-      CALL init_mpi
+        MPI_REAL_LMDZ=MPI_REAL8
+      ELSE
+        CALL init_mpi
+      ENDIF
     ENDIF
-
   END SUBROUTINE Init_const_mpi
   
   SUBROUTINE Init_mpi
-#ifdef CPP_XIOS
-    USE wxios, only: wxios_init
-#endif
+    USE lmdz_mpi
+    USE wxios, only: wxios_init, using_xios
+
   IMPLICIT NONE
-#ifdef CPP_MPI
-     INCLUDE 'mpif.h'
-#endif
     INTEGER             :: ierr
     INTEGER             :: thread_required
     INTEGER             :: thread_provided
 
-#ifdef CPP_MPI
 !$OMP MASTER
       thread_required=MPI_THREAD_SERIALIZED
@@ -87,18 +79,11 @@
 ! Initialisation de XIOS
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-#ifdef CPP_XIOS
-      WRITE(*,*)'IN Init_mpi call wxios_init'
-      CALL wxios_init("LMDZ", outcom=COMM_LMDZ)
-#endif
+      IF (using_xios) THEN
+        WRITE(*,*)'IN Init_mpi call wxios_init'
+        CALL wxios_init("LMDZ", outcom=COMM_LMDZ)
+      ENDIF
 !$OMP END MASTER
-#else
-#ifdef CPP_XIOS
-!$OMP MASTER
-      CALL wxios_init("LMDZ")
-!$OMP END MASTER
-#endif
-#endif
 
-   END SUBROUTINE Init_mpi
+END SUBROUTINE Init_mpi
     
 END MODULE mod_const_mpi
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_filtreg_p.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_filtreg_p.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_filtreg_p.F	(revision 4727)
@@ -55,7 +55,7 @@
 c
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "coefils.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "coefils.h"
 c
       INTEGER,INTENT(IN) :: jjb,jje,ibeg,iend,nlat,nbniv,ifiltre,iter
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_hallo.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_hallo.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_hallo.F90	(revision 4727)
@@ -106,15 +106,9 @@
   
   SUBROUTINE create_global_mpi_buffer
+  USE lmdz_mpi
   IMPLICIT NONE
-#ifdef CPP_MPI
-  INCLUDE 'mpif.h'
-#endif  
     POINTER (Pbuffer,MPI_Buffer(MaxBufferSize))
     REAL :: MPI_Buffer
-#ifdef CPP_MPI
     INTEGER(KIND=MPI_ADDRESS_KIND) :: BS 
-#else
-    INTEGER(KIND=8) :: BS
-#endif
     INTEGER :: i,ierr
 
@@ -122,7 +116,5 @@
       Bs=8*MaxBufferSize
 !$OMP CRITICAL (MPI)
-#ifdef CPP_MPI
       CALL MPI_ALLOC_MEM(BS,MPI_INFO_NULL,Pbuffer,ierr)
-#endif
 !$OMP END CRITICAL (MPI)
       DO i=1,MaxBufferSize
@@ -1157,9 +1149,7 @@
   subroutine Register_Hallo(Field,ij,ll,RUp,Rdown,SUp,SDown,a_request)
   USE dimensions_mod
+  USE lmdz_mpi
       implicit none
 
-#ifdef CPP_MPI
-    include 'mpif.h'
-#endif    
       INTEGER :: ij,ll
       REAL, dimension(ij,ll) :: Field
@@ -1224,8 +1214,6 @@
   subroutine Register_Hallo_u(Field,ll,RUp,Rdown,SUp,SDown,a_request)
   USE dimensions_mod
+  USE lmdz_mpi
       implicit none
-#ifdef CPP_MPI
-    include 'mpif.h'
-#endif    
       INTEGER :: ll
       REAL, dimension(ijb_u:ije_u,ll) :: Field
@@ -1289,8 +1277,6 @@
   subroutine Register_Hallo_v(Field,ll,RUp,Rdown,SUp,SDown,a_request)
   USE dimensions_mod
+  USE lmdz_mpi
       implicit none
-#ifdef CPP_MPI
-    include 'mpif.h'
-#endif    
       INTEGER :: ll
       REAL, dimension(ijb_v:ije_v,ll) :: Field
@@ -1354,9 +1340,6 @@
     subroutine SendRequest(a_Request)
     USE dimensions_mod
+    USE lmdz_mpi
       implicit none
-
-#ifdef CPP_MPI
-      include 'mpif.h'
-#endif
 
       type(request),target :: a_request
@@ -1410,8 +1393,6 @@
 !$OMP CRITICAL (MPI)
          
-#ifdef CPP_MPI
          call MPI_ISEND(Buffer(req%Pos),SizeBuffer,MPI_REAL_LMDZ,rank,a_request%tag+1000*omp_rank,     &
                          COMM_LMDZ,Req%MSG_Request,ierr)
-#endif
          IF (.NOT.using_mpi) THEN
            PRINT *,'Erreur, echange MPI en mode sequentiel !!!'
@@ -1453,8 +1434,7 @@
 !$OMP CRITICAL (MPI)
 
-#ifdef CPP_MPI
              call MPI_IRECV(Buffer(Req%Pos),SizeBuffer,MPI_REAL_LMDZ,rank,a_request%tag+1000*omp_rank,     &
                            COMM_LMDZ,Req%MSG_Request,ierr)
-#endif             
+
              IF (.NOT.using_mpi) THEN
                PRINT *,'Erreur, echange MPI en mode sequentiel !!!'
@@ -1478,9 +1458,6 @@
    subroutine WaitRequest(a_Request)
    USE dimensions_mod
+   USE lmdz_mpi
    implicit none
-   
-#ifdef CPP_MPI
-      include 'mpif.h'   
-#endif
       
       type(request),target :: a_request
@@ -1488,9 +1465,5 @@
       type(Hallo),pointer :: PtrHallo
       integer, dimension(2*mpi_size) :: TabRequest
-#ifdef CPP_MPI
       integer, dimension(MPI_STATUS_SIZE,2*mpi_size) :: TabStatus
-#else
-      integer, dimension(1,2*mpi_size) :: TabStatus
-#endif
       integer :: NbRequest
       integer :: i,rank,pos,ij,l,ierr
@@ -1521,7 +1494,5 @@
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"en attente"
 !        PRINT *,"No des requetes :",TabRequest(1:NbRequest)
-#ifdef CPP_MPI
         call MPI_WAITALL(NbRequest,TabRequest,TabStatus,ierr)
-#endif
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"complete"
 !        PRINT *,"-------------------------------------------------------------------"
@@ -1571,19 +1542,13 @@
      
    subroutine WaitSendRequest(a_Request)
+   USE lmdz_mpi
    USE dimensions_mod
    implicit none
    
-#ifdef CPP_MPI
-      include 'mpif.h'   
-#endif      
       type(request),target :: a_request
       type(request_SR),pointer :: Req
       type(Hallo),pointer :: PtrHallo
       integer, dimension(mpi_size) :: TabRequest
-#ifdef CPP_MPI
       integer, dimension(MPI_STATUS_SIZE,mpi_size) :: TabStatus
-#else
-      integer, dimension(1,mpi_size) :: TabStatus
-#endif
       integer :: NbRequest
       integer :: i,rank,pos,ij,l,ierr
@@ -1606,7 +1571,5 @@
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"en attente"
 !        PRINT *,"No des requetes :",TabRequest(1:NbRequest)
-#ifdef CPP_MPI
-        call MPI_WAITALL(NbRequest,TabRequest,TabStatus,ierr)
-#endif
+         call MPI_WAITALL(NbRequest,TabRequest,TabStatus,ierr)
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"complete"
 !        PRINT *,"-------------------------------------------------------------------"
@@ -1628,19 +1591,11 @@
    subroutine WaitRecvRequest(a_Request)
    USE dimensions_mod
+   USE lmdz_mpi
    implicit none
-   
-#ifdef CPP_MPI
-      include 'mpif.h'   
-#endif
-      
       type(request),target :: a_request
       type(request_SR),pointer :: Req
       type(Hallo),pointer :: PtrHallo
       integer, dimension(mpi_size) :: TabRequest
-#ifdef CPP_MPI
       integer, dimension(MPI_STATUS_SIZE,mpi_size) :: TabStatus
-#else
-      integer, dimension(1,mpi_size) :: TabStatus
-#endif
       integer :: NbRequest
       integer :: i,rank,pos,ij,l,ierr
@@ -1664,7 +1619,5 @@
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"en attente"
 !        PRINT *,"No des requetes :",TabRequest(1:NbRequest)
-#ifdef CPP_MPI
-        call MPI_WAITALL(NbRequest,TabRequest,TabStatus,ierr)
-#endif
+         call MPI_WAITALL(NbRequest,TabRequest,TabStatus,ierr)
 !        PRINT *,"Process de rang",mpi_rank,"Task : ",omp_rank,"--->",NbRequest,"complete"
 !        PRINT *,"-------------------------------------------------------------------"
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_xios_dyn3dmem.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_xios_dyn3dmem.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_xios_dyn3dmem.F90	(revision 4727)
@@ -12,9 +12,8 @@
 !
 !
-#ifdef CPP_XIOS
 
 MODULE mod_xios_dyn3dmem
 
-     USE xios
+     USE lmdz_xios
      USE wxios, ONLY : g_comm
      CHARACTER(len=100), SAVE :: dyn3d_ctx_name = "LMDZDYN"
@@ -259,4 +258,3 @@
    
 END MODULE mod_xios_dyn3dmem 
-#endif
-
+
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgrad_gam_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgrad_gam_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgrad_gam_loc.F	(revision 4727)
@@ -13,7 +13,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
       INTEGER klevel
       REAL rot( ijb_v:ije_v,klevel )
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgrad_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgrad_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgrad_loc.F	(revision 4727)
@@ -12,7 +12,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
       INTEGER klevel
       REAL rot( ijb_v:ije_v,klevel ),x( ijb_u:ije_u,klevel )
